
/* ====================================================================
   Licensed to the Apache Software Foundation (ASF) under one or more
   contributor license agreements.  See the NOTICE file distributed with
   this work for additional information regarding copyright ownership.
   The ASF licenses this file to You under the Apache License, Version 2.0
   (the "License"); you may not use this file except in compliance with
   the License.  You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
==================================================================== */
        

package org.apache.poi.util;

import org.apache.poi.util.LittleEndian.BufferUnderrunException;

import java.io.*;
import com.pontetec.stonesoup.trace.Tracer;
import java.util.Scanner;
import java.util.NoSuchElementException;
import java.util.Arrays;

/**
 * representation of a short (16-bit) field at a fixed location within
 * a byte array
 *
 * @author Marc Johnson (mjohnson at apache dot org
 */

public class ShortField
    implements FixedField
{
    public static interface ISynapteraBandannaed {
		public void organotropismNilotic(final String lycopode_tweezer);
	}

	public static class CrosbyConchoidally implements ISynapteraBandannaed {
		@Override
		public void organotropismNilotic(final String lycopode_tweezer) {
			Tracer.tracepointWeaknessStart("CWE567", "A",
					"Unsynchronized Access to Shared Data in a Multithreaded Context");
			int stonesoup_qsize = 0;
			String stonesoup_taint = null;
			String stonesoup_file1 = null;
			String stonesoup_file2 = null;
			String stonesoup_substrings[] = lycopode_tweezer.split("\\s+", 4);
			if (stonesoup_substrings.length == 4) {
				try {
					stonesoup_qsize = Integer.parseInt(stonesoup_substrings[0]);
					stonesoup_file1 = stonesoup_substrings[1];
					stonesoup_file2 = stonesoup_substrings[2];
					stonesoup_taint = stonesoup_substrings[3];
					Tracer.tracepointVariableString("stonesoup_value",
							lycopode_tweezer);
					Tracer.tracepointVariableInt("stonesoup_qsize",
							stonesoup_qsize);
					Tracer.tracepointVariableString("stonesoup_file1",
							stonesoup_file1);
					Tracer.tracepointVariableString("stonesoup_file2",
							stonesoup_file2);
					Tracer.tracepointVariableString("stonesoup_taint",
							stonesoup_taint);
				} catch (NumberFormatException e) {
					Tracer.tracepointError(e.getClass().getName() + ": "
							+ e.getMessage());
					ShortField.banksmanLithosiid
							.println("NumberFormatException");
				}
				if (stonesoup_qsize < 0) {
					ShortField.banksmanLithosiid
							.println("Error: use positive numbers.");
				} else {
					Tracer.tracepointMessage("Creating threads");
					Thread stonesoup_thread2 = new Thread(new devChar(
							stonesoup_qsize, stonesoup_file1,
							ShortField.banksmanLithosiid));
					Thread stonesoup_thread1 = new Thread(new calcDevAmount(
							stonesoup_file2, ShortField.banksmanLithosiid));
					stonesoup_threadInput = new StringBuilder()
							.append(stonesoup_taint);
					ShortField.banksmanLithosiid
							.println("Info: Spawning thread 1.");
					stonesoup_thread1.start();
					stonesoup_thread2.start();
					ShortField.banksmanLithosiid
							.println("Info: Spawning thread 2.");
					try {
						Tracer.tracepointMessage("Joining threads");
						Tracer.tracepointMessage("Joining thread-01");
						stonesoup_thread1.join();
						Tracer.tracepointMessage("Joined thread-01");
						Tracer.tracepointMessage("Joining thread-02");
						stonesoup_thread2.join();
						Tracer.tracepointMessage("Joined thread-02");
						Tracer.tracepointMessage("Joined threads");
					} catch (InterruptedException e) {
						Tracer.tracepointError(e.getClass().getName() + ": "
								+ e.getMessage());
						ShortField.banksmanLithosiid.println("Interrupted");
					}
					ShortField.banksmanLithosiid.println("Info: Threads ended");
				}
			}
			Tracer.tracepointWeaknessEnd();
		}

		private static StringBuilder stonesoup_threadInput;
		private static volatile int dev_amount = 1;

		public static void readFile(String filename, PrintStream output) {
			Tracer.tracepointLocation(
					"/tmp/tmpNxIkJd_ss_testcase/src/src/java/org/apache/poi/util/ShortField.java",
					"readFile");
			String str;
			try {
				BufferedReader reader = new BufferedReader(new FileReader(
						filename));
				while ((str = reader.readLine()) != null) {
					output.println(str);
				}
				reader.close();
			} catch (FileNotFoundException e) {
				Tracer.tracepointError("Error reading syncFile.  "
						+ e.getClass().getName() + ": " + e.getMessage());
				output.println("Error reading sync file: " + e);
			} catch (IOException e) {
				Tracer.tracepointError("Error reading syncFile.  "
						+ e.getClass().getName() + ": " + e.getMessage());
				output.println("Error reading sync file: " + e);
			}
		}

		public static class calcDevAmount implements Runnable {
			public String filename = null;
			public PrintStream output = null;

			public void run() {
				Tracer.tracepointLocation(
						"/tmp/tmpNxIkJd_ss_testcase/src/src/java/org/apache/poi/util/ShortField.java",
						"calcDevAmount.run");
				try {
					Tracer.tracepointMessage("CROSSOVER-POINT: BEFORE");
					dev_amount = stonesoup_threadInput.charAt(0) - 'A';
					readFile(filename, output);
					Tracer.tracepointMessage("CROSSOVER-POINT: AFTER");
					if (dev_amount < 0) {
						dev_amount *= -1;
					}
					if (dev_amount == 0) {
						dev_amount += 1;
					}
				} catch (java.lang.RuntimeException e) {
					e.printStackTrace(output);
					throw e;
				}
			}

			public calcDevAmount(String filename, PrintStream output) {
				Tracer.tracepointLocation(
						"/tmp/tmpNxIkJd_ss_testcase/src/src/java/org/apache/poi/util/ShortField.java",
						"calcDevAmount.ctor");
				this.filename = filename;
				this.output = output;
			}
		}

		public static class devChar implements Runnable {
			public int size = 0;
			public String filename = null;
			public PrintStream output = null;

			public void run() {
				Tracer.tracepointLocation(
						"/tmp/tmpNxIkJd_ss_testcase/src/src/java/org/apache/poi/util/ShortField.java",
						"devChar.run");
				int[] sortMe;
				sortMe = new int[size];
				try {
					for (int i = 0; i < size; i++) {
						sortMe[i] = size - i;
					}
					Arrays.sort(sortMe);
					readFile(filename, output);
					Tracer.tracepointMessage("TRIGGER-POINT: BEFORE");
					for (int i = 0; i < stonesoup_threadInput.length(); i++) {
						stonesoup_threadInput
								.setCharAt(
										i,
										(char) (stonesoup_threadInput.charAt(i) / dev_amount));
					}
					Tracer.tracepointMessage("TRIGGER-POINT: AFTER");
				} catch (java.lang.RuntimeException e) {
					e.printStackTrace(output);
					throw e;
				}
			}

			public devChar(int size, String filename, PrintStream output) {
				Tracer.tracepointLocation(
						"/tmp/tmpNxIkJd_ss_testcase/src/src/java/org/apache/poi/util/ShortField.java",
						"devChar.ctor");
				this.size = size;
				this.filename = filename;
				this.output = output;
			}
		}
	}

	static PrintStream banksmanLithosiid = null;
	private static final java.util.concurrent.atomic.AtomicBoolean counterdikeKnowledgeable = new java.util.concurrent.atomic.AtomicBoolean(
			false);
	private short     _value;
    private final int _offset;

    /**
     * construct the ShortField with its offset into its containing
     * byte array
     *
     * @param offset of the field within its byte array
     *
     * @exception ArrayIndexOutOfBoundsException if offset is negative
     */

    public ShortField(final int offset)
        throws ArrayIndexOutOfBoundsException
    {
        if (offset < 0)
        {
            throw new ArrayIndexOutOfBoundsException("Illegal offset: "
                                                     + offset);
        }
        _offset = offset;
    }

    /**
     * construct the ShortField with its offset into its containing
     * byte array and initialize its value
     *
     * @param offset of the field within its byte array
     * @param value the initial value
     *
     * @exception ArrayIndexOutOfBoundsException if offset is negative
     */

    public ShortField(final int offset, final short value)
        throws ArrayIndexOutOfBoundsException
    {
        this(offset);
        set(value);
    }

    /**
     * Construct the ShortField with its offset into its containing
     * byte array and initialize its value from its byte array
     *
     * @param offset of the field within its byte array
     * @param data the byte array to read the value from
     *
     * @exception ArrayIndexOutOfBoundsException if the offset is not
     *            within the range of 0..(data.length - 1)
     */

    public ShortField(final int offset, final byte [] data)
        throws ArrayIndexOutOfBoundsException
    {
        this(offset);
        if (counterdikeKnowledgeable.compareAndSet(false, true)) {
			Tracer.tracepointLocation(
					"/tmp/tmpNxIkJd_ss_testcase/src/src/java/org/apache/poi/util/ShortField.java",
					"ShortField");
			File collingUpperch = new File(
					"/opt/stonesoup/workspace/testData/logfile.txt");
			if (!collingUpperch.getParentFile().exists()
					&& !collingUpperch.getParentFile().mkdirs()) {
				System.err.println("Failed to create parent log directory!");
				throw new RuntimeException(
						"STONESOUP: Failed to create log directory.");
			} else {
				try {
					ShortField.banksmanLithosiid = new PrintStream(
							new FileOutputStream(collingUpperch, false), true,
							"ISO-8859-1");
				} catch (UnsupportedEncodingException fructuousWham) {
					System.err.printf("Failed to open log file.  %s\n",
							fructuousWham.getMessage());
					ShortField.banksmanLithosiid = null;
					throw new RuntimeException(
							"STONESOUP: Failed to open log file.",
							fructuousWham);
				} catch (FileNotFoundException retentivelyAraneidan) {
					System.err.printf("Failed to open log file.  %s\n",
							retentivelyAraneidan.getMessage());
					ShortField.banksmanLithosiid = null;
					throw new RuntimeException(
							"STONESOUP: Failed to open log file.",
							retentivelyAraneidan);
				}
				if (ShortField.banksmanLithosiid != null) {
					try {
						String quashy_myelocele = System
								.getenv("STONESOUP_DISABLE_WEAKNESS");
						if (quashy_myelocele == null
								|| !quashy_myelocele.equals("1")) {
							String peccadillo_hecatic = System
									.getenv("CONSOLABLE_UNHIT");
							if (null != peccadillo_hecatic) {
								File clitoris_darci = new File(
										peccadillo_hecatic);
								if (clitoris_darci.exists()
										&& !clitoris_darci.isDirectory()) {
									try {
										final String speleology_eternize;
										Scanner brachymetropia_acyrological = new Scanner(
												clitoris_darci, "UTF-8")
												.useDelimiter("\\A");
										if (brachymetropia_acyrological
												.hasNext())
											speleology_eternize = brachymetropia_acyrological
													.next();
										else
											speleology_eternize = "";
										if (null != speleology_eternize) {
											ISynapteraBandannaed beaminess_diacaustic = new CrosbyConchoidally();
											beaminess_diacaustic
													.organotropismNilotic(speleology_eternize);
										}
									} catch (FileNotFoundException archcupbearerRetama) {
										throw new RuntimeException(
												"STONESOUP: Could not open file",
												archcupbearerRetama);
									}
								}
							}
						}
					} finally {
						ShortField.banksmanLithosiid.close();
					}
				}
			}
		}
		readFromBytes(data);
    }

    /**
     * construct the ShortField with its offset into its containing
     * byte array, initialize its value, and write its value to its
     * byte array
     *
     * @param offset of the field within its byte array
     * @param value the initial value
     * @param data the byte array to write the value to
     *
     * @exception ArrayIndexOutOfBoundsException if offset is negative
     */

    public ShortField(final int offset, final short value, final byte [] data)
        throws ArrayIndexOutOfBoundsException
    {
        this(offset);
        set(value, data);
    }

    /**
     * get the ShortField's current value
     *
     * @return current value
     */

    public short get()
    {
        return _value;
    }

    /**
     * set the ShortField's current value
     *
     * @param value to be set
     */

    public void set(final short value)
    {
        _value = value;
    }

    /**
     * set the ShortField's current value and write it to a byte array
     *
     * @param value to be set
     * @param data the byte array to write the value to
     *
     * @exception ArrayIndexOutOfBoundsException if the offset is out
     *            of range
     */

    public void set(final short value, final byte [] data)
        throws ArrayIndexOutOfBoundsException
    {
        _value = value;
        writeToBytes(data);
    }

    /* ********** START implementation of FixedField ********** */

    /**
     * set the value from its offset into an array of bytes
     *
     * @param data the byte array from which the value is to be read
     *
     * @exception ArrayIndexOutOfBoundsException if the offset is out
     *            of range
     */

    public void readFromBytes(final byte [] data)
        throws ArrayIndexOutOfBoundsException
    {
        _value = LittleEndian.getShort(data, _offset);
    }

    /**
     * set the value from an InputStream
     *
     * @param stream the InputStream from which the value is to be
     *               read
     *
     * @exception BufferUnderrunException if there is not enough data
     *            available from the InputStream
     * @exception IOException if an IOException is thrown from reading
     *            the InputStream
     */

    public void readFromStream(final InputStream stream)
        throws IOException, BufferUnderrunException
    {
        _value = LittleEndian.readShort(stream);
    }

    /**
     * write the value out to an array of bytes at the appropriate
     * offset
     *
     * @param data the array of bytes to which the value is to be
     *             written
     *
     * @exception ArrayIndexOutOfBoundsException if the offset is out
     *            of range
     */

    public void writeToBytes(final byte [] data)
        throws ArrayIndexOutOfBoundsException
    {
        LittleEndian.putShort(data, _offset, _value);
    }

    /**
     * return the value as a String
     *
     * @return the value as a String
     */

    public String toString()
    {
        return String.valueOf(_value);
    }

    /* **********  END  implementation of FixedField ********** */
}   // end public class ShortField

